////////////////////////////////////////////////////////////////////////
//                                                                    //
// MicrOTP: A tool for computing one time passwords for S/Key logins. //
//                                                                    //
// (C) 2008 Tom Bramer                                                //
//                                                                    //
// This program is free software; you can redistribute it and/or      //
// modify it under the terms of the GNU General Public License        //
// as published by the Free Software Foundation; either version 2     //
// of the License, or (at your option) any later version.             //
//                                                                    //
// This program is distributed in the hope that it will be useful,    //
// but WITHOUT ANY WARRANTY; without even the implied warranty of     //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      //
// GNU General Public License for more details.                       //
//                                                                    //
// You should have received a copy of the GNU General Public License  //
// along with this program; if not, write to the Free Software        //
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA      //
// 02110-1301, USA.                                                   //
//                                                                    //
////////////////////////////////////////////////////////////////////////

// otp3View.h : interface of the COtp3View class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OTP3VIEW_H__3DB9AFAA_9914_4BA3_B9AD_51630028427B__INCLUDED_)
#define AFX_OTP3VIEW_H__3DB9AFAA_9914_4BA3_B9AD_51630028427B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class COtp3View : public CFormView
{
protected: // create from serialization only
	COtp3View();
	DECLARE_DYNCREATE(COtp3View)

public:
	//{{AFX_DATA(COtp3View)
	enum { IDD = IDD_OTP3_FORM };
	CString	challenge_;
	int		method_;
	CString	secret_;
	CString	result_;
	//}}AFX_DATA

// Attributes
public:
	COtp3Doc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COtp3View)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COtp3View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(COtp3View)
	afx_msg void OnCalc();
	afx_msg void OnSelchangeMethod();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in otp3View.cpp
inline COtp3Doc* COtp3View::GetDocument()
   { return (COtp3Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OTP3VIEW_H__3DB9AFAA_9914_4BA3_B9AD_51630028427B__INCLUDED_)
